<template>
    <div class="edit-view">
        <el-form :model="formData" :rules="rules" ref="form" label-width="80px" label-position="right" size="small"
                 style="max-width: 500px;">
                <el-form-item prop="userId" label="用户ID">
                            <el-input-number type="number" v-model="formData.userId"></el-input-number>
                </el-form-item>
                <el-form-item prop="merchantId" label="商户ID">
                            <el-input-number type="number" v-model="formData.merchantId"></el-input-number>
                </el-form-item>
                <el-form-item prop="deliveryAmount" label="配送费">
                            <el-input-number type="number" v-model="formData.deliveryAmount"></el-input-number>
                </el-form-item>
                <el-form-item prop="totalAmount" label="总价">
                            <el-input-number type="number" v-model="formData.totalAmount"></el-input-number>
                </el-form-item>
                <el-form-item prop="amount" label="已减优惠">
                            <el-input-number type="number" v-model="formData.amount"></el-input-number>
                </el-form-item>
                <el-form-item prop="packingPrice" label="包装价格">
                            <el-input-number type="number" v-model="formData.packingPrice"></el-input-number>
                </el-form-item>
                <el-form-item prop="couponId" label="优惠券ID">
                            <el-input-number type="number" v-model="formData.couponId"></el-input-number>
                </el-form-item>
                <el-form-item prop="fullReduction" label="满减">
                            <el-input-number type="number" v-model="formData.fullReduction"></el-input-number>
                </el-form-item>
                <el-form-item prop="firstBuy" label="首单">
                            <el-input-number type="number" v-model="formData.firstBuy"></el-input-number>
                </el-form-item>
                <el-form-item prop="redBag" label="红包">
                            <el-input-number type="number" v-model="formData.redBag"></el-input-number>
                </el-form-item>
                <el-form-item prop="newUser" label="新用户">
                            <el-input-number type="number" v-model="formData.newUser"></el-input-number>
                </el-form-item>
                <el-form-item prop="total" label="总价">
                            <el-input-number type="number" v-model="formData.total"></el-input-number>
                </el-form-item>
                <el-form-item prop="realAmount" label="实付金额">
                            <el-input-number type="number" v-model="formData.realAmount"></el-input-number>
                </el-form-item>
            <el-form-item>
                <el-button @click="onSave" :loading="saving"
                           type="primary">保存</el-button>
                <el-button @click="onDelete" :loading="saving"
                           type="danger" v-if="formData.id">删除
                </el-button>
                <el-button @click="$router.go(-1)">取消</el-button>
            </el-form-item>
        </el-form>
    </div>
</template>
<script>
    export default {
        name: 'ShoppingCartEdit',
        created() {
            if (this.$route.query.id) {
                this.$http
                    .get('shoppingCart/get/'+this.$route.query.id)
                    .then(res => {
                        this.formData = res;
                    })
                    .catch(e => {
                        console.log(e);
                        this.$message.error(e.error);
                    });
            }
        },
        data() {
            return {
                saving: false,
                formData: {
                },
                rules: {
                },
            }
        },
        methods: {
            onSave() {
                this.$refs.form.validate((valid) => {
                    if (valid) {
                        this.submit();
                    } else {
                        return false;
                    }
                });
            },
            submit() {
                let data = {...this.formData};

                this.saving = true;
                this.$http
                    .post('/shoppingCart/save', data, {body: 'json'})
                    .then(res => {
                        this.saving = false;
                        this.$message.success('成功');
                        this.$router.go(-1);
                    })
                    .catch(e => {
                        console.log(e);
                        this.saving = false;
                        this.$message.error(e.error);
                    });
            },
            onDelete() {
                this.$alert('删除将无法恢复，确认要删除么？', '警告', {type: 'error'}).then(() => {
                    return this.$http.post(`/shoppingCart/del/${this.formData.id}`)
                }).then(() => {
                    this.$message.success('删除成功');
                    this.$router.go(-1);
                }).catch(e => {
                    if (e !== 'cancel') {
                        console.log(e);
                        this.$message.error(e.error);
                    }
                })
            },
        }
    }
</script>
<style lang="less" scoped>
</style>
